package ru.landgrafhomyak.serdha.api.v0.table

import ru.landgrafhomyak.serdha.api.v0.misc._Selectable
import ru.landgrafhomyak.serdha.api.v0.module.Module

public interface Table<UserExtension : Any, PreviousUserExtension : Any> : _Selectable<UserExtension> {
	public val userExtension: UserExtension
	public val name: String
	public val module: Module<*>

	public enum class TemporaryType {
		TRANSACTION_SCOPE,
		CONNECTION_SCOPE
	}

	public val temporaryType: TemporaryType?

	// todo make nullable for temp tables
	public val namespacesFromModuleRoot: List<String>
}